# This is example for GraphQL scheme.  
# Change this file structure for your tasks

interface PEEvent

scalar HTML
scalar Float
scalar URL
scalar Color
scalar EmailAddress
scalar Media
scalar DateTime
scalar Role

enum FestivalStatus {
    BEFORE_START
    STARTED
    FINISHED
    ARCHIVED
}
enum RatingType {
    EACH_CATEGORY
    DISTRIBUTION_PROCENTAGE
    INDEPENDED_GRADE
}
enum ProjectResultType {
    SUMMAE
    AVERAGE
    SUMMAE_MILESTONE
}
enum MemberCardType {
    BOX
    SIMPLE_STROKE
    STROKE
    CARD
    TWO_SIZE_CARD
}

enum Status {
    PUBLISH
    HIDDEN
    TRASH
}

enum PaginOrder {
    ASC
    DESC
}

type User
{
    name: String
    roles: [Role]
    email: EmailAddress
}
input UserInput
{
    name: String
    roles: [Role]
    email: EmailAddress
}

input PagingInput
{
    offset:Int
    count:Int
    order: String
}

schema {
    query: Query
    mutation: Mutation
}

type Query {
    getFestival(id: String, festivalId:String): Festival
    getFestivals(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [Festival]
    getFestivalCount(filter: FestFilterInput, sort: FestivalSortInput ): Int
    
    getFestFamily(id: String!): FestFamily
    getFestFamilies(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [FestFamily]
    getFestFamilyCount(filter: FestFilterInput, sort: FestivalSortInput ): Int
    
    getDomainType(id: String!): DomainType
    getDomainTypes(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [DomainType]
    getDomainTypeCount(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): Int
    
    getTrack(id: String!): Track
    getTracks(filter: TrackFilterInput, sort: FestivalSortInput, paging: PagingInput ): [Track]
    getTrackCount(filter: FestFilterInput, sort: FestivalSortInput ): Int
    
    getHoneycombs(id: String!): Honeycombs
    getHoneycombss(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [Honeycombs]
    getHoneycombsCount(filter: FestFilterInput, sort: FestivalSortInput ): Int

    getExtendFields(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [ExtendField]
    
    getPosts(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [Post]
    getPostCount(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): Int

    getProject(id: String!): Project
    getProjects(filter: ProjectFilterInput, sort: FestivalSortInput, paging: PagingInput ): [Project]
    getProjectCount(filter: ProjectFilterInput, sort: FestivalSortInput ): Int

    getCategory(id: String!): Category
    getCategories(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [Category]
    getCategoryCount(filter: FestFilterInput, sort: FestivalSortInput ): Int

    getCritery(id: String!): Critery
    getCriteries(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [Critery]
    getCriteryCount(filter: FestFilterInput, sort: FestivalSortInput ): Int

    getGanre(id: String!): Ganre
    getGanres(filter: FestFilterInput, sort: FestivalSortInput, paging: PagingInput ): [Ganre]
    getGanreCount(filter: FestFilterInput, sort: FestivalSortInput ): Int

}

type Mutation {
    correctRating(input: CorrectProjectRateInput): Int


    insertFestival(input: FestivalInput): Festival
    changeFestival(id: String, input: FestivalInput): Festival
    deleteFestival(id: String): Boolean

    insertFestFamily(input: FestFamilyInput): FestFamily
    insertDomainType(input: DomainTypeInput): DomainType
    insertTrack(input: TrackInput): Track
    insertHoneycombs(input: HoneycombsInput): Honeycombs
    insertGanre(input: GanreInput): Ganre
    insertPost(input: PostInput): Post

    insertProject(input: ProjectInput): Project
    changeProject(input: ProjectInput): Project
    deleteProject(input: ProjectInput): Boolean
}

"""
module: fest-module
"""
type Festival implements PEEvent{
    id: String
    title: String
    festivalId: String
    tagline: String
    """
    Main festival description
    """
    description: HTML
    vk: URL
    vk2: URL
    email: EmailAddress
    email2: EmailAddress
    phone: String
    phone2: String
    telegram: URL
    telegram2: URL
    link1: URL
    link2: URL
    family: FestFamily
    isDomainType: Boolean
    domainType: DomainType
    domain: URL
    icon: Media
    logotype: Media
    thumbnail: Media
    defaultProjectThumbnail: Media
    createUser: User
    users:[User]
    ownerUser: User
    milestones: [Milestone]
    tracks: [Track]
    honeycombs: [Honeycombs]
    criteries: [Critery]
    categories: [Category]
    ganres: [Ganre]
    projects: [Project]
    posts: [Post]
    festivalStatus: FestivalStatus
    startDate: DateTime
    finishDate: DateTime
    ratingType: RatingType
    displayProjectResult: ProjectResultType
    maxRating: Int
    availableRoles: [Role]
    maxMemberId: Int
    isIndependentGradeCritery: Boolean
    isExpertsCriteries: Boolean
    isOwnerRate: Boolean
    isGanres: Boolean
    isRegisterUser: Boolean
    isRegisterProject: Boolean
    isDiary: Boolean    
    memberCardType: MemberCardType
    memberCardHeight: Int
    memberPerPage: Int
    horoRaiting: Int
    isChangeCardType: Boolean
    enabledRules: Boolean
    enabledReglament: Boolean
    reglament: HTML
    isShowMap: Boolean
    newProjectEmail: HTML
    newProjectMessage: HTML
    extendFields: [ExtendField]
    status: Status
}

input FestivalInput {
    id: String
    title: String
    tagline: String
    festivalId: String
    description: HTML
    family: FestFamilyInput
    isDomainType: Boolean
    domainType: DomainTypeInput
    domain: URL
    vk: URL
    vk2: URL
    email: EmailAddress
    email2: EmailAddress
    phone: String
    phone2: String
    telegram: URL
    telegram2: URL
    link1: URL
    link2: URL
    icon: Media
    logotype: Media
    thumbnail: Media
    defaultProjectThumbnail: Media
    milestones: [MilestoneInput]
    tracks: [TrackInput]
    honeycombs: [HoneycombsInput]
    criteries: [CriteryInput]
    categories: [CategoryInput]
    ganres: [GanreInput]
    projects: [ProjectInput]
    posts: [PostInput]
    isRegisterProject: Boolean 
    users:[UserInput]
    createUser:UserInput
    ownerUser: UserInput 
    festivalStatus: FestivalStatus
    startDate: DateTime
    finishDate: DateTime
    ratingType: RatingType
    displayProjectResult: ProjectResultType
    maxRating: Int
    availableRoles: [Role]
    maxMemberId: Int
    isIndependentGradeCritery: Boolean
    isOwnerRate: Boolean
    isGanres: Boolean
    isRegisterUser: Boolean
    isDiary: Boolean
    memberCardType: MemberCardType
    memberCardHeight: Int
    isChangeCardType: Boolean
    enabledRules: Boolean
    enabledReglament: Boolean
    reglament: HTML
    isShowMap: Boolean
    newProjectEmail: HTML
    newProjectMessage: HTML 
    status: Status
}
input FestFilterInput {
    startDate: DateTime
    finishDate: DateTime
    ownerUser: [UserInput]
    domainType: DomainTypeInput
    isDomainType: Boolean
    festivalStatus: FestivalStatus
    status: Status
    search: String
}
input FestivalSortInput {
    sort: String!
}
type FestFamily {
    id: String
    title: String
    festivals: [Festival]
    status: Status
}
input FestFamilyInput {
    id: String
    title: String 
    status: Status
}

type DomainType {
    id: String
    title: String
    description: HTML
    festivals: [Festival]
    status: Status
}
input DomainTypeInput {
    id:String
    title: String
    status: Status
}

type Critery {
    id: String
    title: String
    order: Int
    milestone: Milestone
    category: Category
    festival: Festival
    ganre: Ganre
    maxRating: Int
    status: Status
}

input CriteryInput {
    id: String
    title: String
    order: Int
    milestone: MilestoneInput
    category: CategoryInput
    ganre: GanreInput
    maxRating: Int
    status: Status
}

type Project {
    id: String
    title: String
    festival: Festival
    description: HTML
    order: Int
    thumbnail: Media
    track: Track
    ganres: [Ganre]
    honeycombs: Honeycombs
    tutor: User
    author: User
    members: [User]
    experts: [User]
    extendedFields: [Field]
    correctMemberRate : [CorrectProjectRate]
    status: Status
    averageRating: Float
    version: Int
}

input ProjectInput {
    id: String
    title: String
    festival: FestivalInput
    description: HTML
    order: Int
    thumbnail: Media
    track: TrackInput
    honeycombs: HoneycombsInput
    tutor: UserInput
    author: UserInput
    members: [UserInput]
    extendedFields: [FieldInput]
    status: Status
    averageRating: Float
    version: Int
}

input ProjectFilterInput {
    id: String
    title: String
    festival: FestivalInput
    track: TrackInput
    honeycombs: HoneycombsInput
    genres:[GanreInput]
    tutor: UserInput
    author: UserInput
    status: Status
    search: String
}

type CorrectProjectRate {
    project: Project
    festival: Festival
    rating: Float
    description: String
    user: User
}

input CorrectProjectRateInput {
    project: ProjectInput!
    festival: FestivalInput
    rating: Float
    description: String
    user: UserInput
}

type Track
{
    id: String
    title: String
    festival: Festival
    description: HTML
    order: Int
    icon: Media
    thumbnail: Media
    isRegisterOpen: Boolean
    youtubeID: String
    moderators: [User]
    status: Status
}

input TrackInput
{
    id: String
    title: String
    festival: FestivalInput
    description: HTML
    order: Int
    icon: Media
    thumbnail: Media
    isRegisterOpen: Boolean
    youtubeID: String 
    status: Status
}

input TrackFilterInput {
    id: String
    festival: FestivalInput
    isRegisterOpen: Boolean
    status: Status
}

type Honeycombs
{
    id: String!
    title: String
    order: Int
    status: Status
    festival: Festival
}

input HoneycombsInput
{
    id: String!
    title: String
    order: Int
    status: Status
    festival: FestivalInput
}

type Post {
    id: String
    title: String
    content: HTML
    status: Status
    festival: Festival
}

input PostInput {
    id: String
    title: String
    content: HTML
    status: Status
    festival: FestivalInput
}

type Milestone {
    id: String
    title: String
    order:Int
    status: Status
    festival: Festival
}
input MilestoneInput {
    id: String
    title: String
    order:Int
    status: Status
    festival: FestivalInput
}

input CategoryInput {
    id: String
    title: String
    order:Int
    color: Color
    status: Status
    festival: FestivalInput
}

type Category {
    id: String
    title: String
    order:Int
    color: Color
    status: Status
    festival: Festival
}

input GanreInput {
    id: String
    title: String
    icon: Media
    order:Int
    status: Status
    festival: FestivalInput
}

type Ganre {
    id: String
    title: String
    icon: Media
    order:Int
    status: Status
    festival: Festival
} 

type ExtendField {
    id: String
    title: String
    name: String
    order:Int
    isRequired: Boolean
    count: Int
    type: String
    isHidden: Boolean
    isCardHidden: Boolean
    isAdminHidden: Boolean
    festival: Festival
}

input ExtendFieldInput {
    id: String
    title: String
    name: String
    order:Int
    isRequired: Boolean
    count: Int
    type: String
    isHidden: Boolean
    isCardHidden: Boolean
    isAdminHidden: Boolean
    festival: FestivalInput
}

type Field
{
    id: String
    order:Int
    extendedField: ExtendField
}

input FieldInput
{
    id: String
    order:Int
    extendedField: ExtendFieldInput
}